
package mx.uls.edu.cib4122006.swingui;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextArea;


public class ArchivoTexto extends VentanaInicial {
	private JTextArea editor ;
	
	
	public class HandlerAbrir implements ActionListener {
		
		
		public void actionPerformed(ActionEvent arg0) {
			JFileChooser c = new JFileChooser();
			
			int rVal = c.showOpenDialog(ArchivoTexto.this.getFrame());
			if (rVal==JFileChooser.APPROVE_OPTION){
				ArchivoTexto.this.abrir(c.getSelectedFile());
				imprimir(c.getSelectedFile().getAbsolutePath());
				imprimirnl();
			} else if (rVal== JFileChooser.CANCEL_OPTION){
				imprimir("Abrir Cancelado");
				imprimirnl();
			}
		}
		
	}
	private class HandlerSalvar implements ActionListener {
		
		
		public void actionPerformed(ActionEvent arg0) {
			JFileChooser c= new JFileChooser();
			int rVal = c.showSaveDialog(ArchivoTexto.this.getFrame());
			if (rVal == JFileChooser.APPROVE_OPTION){
				imprimir(c.getSelectedFile().getName());
				imprimirnl();
				imprimir(c.getCurrentDirectory().getName());
				imprimirnl();
				imprimir(c.getSelectedFile().getAbsolutePath());
				ArchivoTexto.this.guardar(c.getSelectedFile());
			} else if (rVal == JFileChooser.CANCEL_OPTION){
				imprimir("GuardarCancelado");
				imprimirnl();
			}
			
		}
		
	}
	private class HandlerSalir implements ActionListener {
		public void actionPerformed(ActionEvent arg0) {
			System.exit(0);
			
		}
		
	}
	
	
	private void abrir(File archivo){
		try {
			this.editor.setText("");	
			FileReader lector = new FileReader(archivo);
			BufferedReader l= new BufferedReader(lector);
			String contenido;
			while ((contenido=l.readLine())!=null){
				this.editor.append(contenido);
				this.editor.append("\n");
			}
			l.close();
			lector.close();
			
			
		} catch (FileNotFoundException ex){
			imprimir(ex.getMessage());
			imprimirnl();
		} catch (IOException ex){
			imprimir(ex.getMessage());
			imprimirnl();
		}
		
	}
	private void guardar(File archivo){
		try {
			FileWriter escritor = new FileWriter(archivo);
			BufferedWriter e= new BufferedWriter(escritor);
			
			String texto = this.editor.getText();
			
			e.write(texto);
			
			e.close();
			escritor.close();
			
		} catch (FileNotFoundException ex){
			imprimir(ex.getMessage());
			imprimirnl();
		} catch (IOException ex){
			imprimir(ex.getMessage());
			imprimirnl();
		}
	}
	private void menuArchivo(){
		JFrame fr= super.getFrame();
		JMenuBar barra= new JMenuBar();
		
		JMenu menu= new JMenu("Archivo");
		JMenuItem [] opciones = {
				new JMenuItem("Abrir",KeyEvent.VK_A),
				new JMenuItem("Guardar",KeyEvent.VK_G),
				new JMenuItem("Salir",KeyEvent.VK_S)
		};
		ActionListener [] handlers={
				new HandlerAbrir(),
				new HandlerSalvar(),
				new HandlerSalir()
		};
		
		for (int i=0;i<opciones.length;i++){
			menu.add(opciones[i]);
			opciones[i].addActionListener(handlers[i]);
		}
		barra.add(menu);
		fr.setJMenuBar(barra);
	}
	
	public final void dibujar() {
		Container ct= super.getContainer();
		editor = new JTextArea(10,15);
		this.menuArchivo();
		ct.add(editor);
	}
	
	public static void main(String[] args) {
		new ArchivoTexto();
	}
}
