package mx.uls.edu.cib4122006.swingui;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

public class ConvertidorUI extends JFrame {
	public final static String TIP_JLCENTIGRADOS="Introducir grados centigrados";
	public final static String TIP_JLFAHRENHEIT="Introducir grados fahrenheit";
	public final static String TIP_JTCAPTURA="Introducir numeros reales, teclear Enter";
	public final static Color COLOR_CAPTURA=new Color(255,240,230);
	private static final long serialVersionUID = 1L;
	protected JTextField jtfCentigrados;
	protected JTextField jtfFahrenheit;
	/**
	 * @param titulo
	 */
	public ConvertidorUI(String titulo)  {
		super(titulo);
		super.setSize(new Dimension(400,200));
		super.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		super.setLayout(new FlowLayout());
	}
	public void iniciar(){
		//primer panel
		JPanel panel01 = new JPanel();
		JLabel jlCentigrados = new JLabel();
		this.jtfCentigrados = new JTextField();
		//configurar etiqueta centigrados
		jlCentigrados.setFont(new Font("Courier",Font.BOLD,12));
		jlCentigrados.setText("Grados Centigrados");
		jlCentigrados.setToolTipText(ConvertidorUI.TIP_JLCENTIGRADOS);
		jlCentigrados.setHorizontalAlignment(SwingConstants.LEFT);
		//configurar texto de centigrados
		this.jtfCentigrados.setColumns(10);
		this.jtfCentigrados.setToolTipText(ConvertidorUI.TIP_JTCAPTURA);
		this.jtfCentigrados.setFont(new Font("Arial",Font.ITALIC,12));
		this.jtfCentigrados.setBackground(ConvertidorUI.COLOR_CAPTURA);
		this.jtfCentigrados.setForeground(Color.DARK_GRAY);
		this.jtfCentigrados.setHorizontalAlignment(SwingConstants.RIGHT);
		panel01.add(jlCentigrados); panel01.add(this.jtfCentigrados);
		panel01.setBorder(BorderFactory.createTitledBorder("Centigrados"));
		//segundo panel
		JPanel panel02 = new JPanel();
		JLabel jlFahrenheit = new JLabel();
		this.jtfFahrenheit = new JTextField();
		jlFahrenheit.setFont(new Font("Courier",Font.BOLD,12));
		jlFahrenheit.setText("Grados Fahrenheit");
		jlFahrenheit.setToolTipText(ConvertidorUI.TIP_JLFAHRENHEIT);
		jlFahrenheit.setHorizontalAlignment(SwingConstants.LEFT);
		this.jtfFahrenheit.setColumns(10);
		this.jtfFahrenheit.setToolTipText(ConvertidorUI.TIP_JTCAPTURA);
		this.jtfFahrenheit.setFont(new Font("Arial",Font.ITALIC,12));
		this.jtfFahrenheit.setBackground(ConvertidorUI.COLOR_CAPTURA);
		this.jtfFahrenheit.setForeground(Color.DARK_GRAY);
		this.jtfFahrenheit.setHorizontalAlignment(SwingConstants.RIGHT);
		panel02.add(jlFahrenheit); panel02.add(this.jtfFahrenheit);
		panel02.setBorder(BorderFactory.createTitledBorder("Fahrenheit"));
		//acciones
		this.jtfCentigrados.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent elEvento) {
						jtfCentigradosEvento(elEvento);
					}
				}	
		);
		this.jtfFahrenheit.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent elEvento) {
						jtfFahrenheitEvento(elEvento);
					}
				}
		);
		//agregar paneles
		super.getContentPane().add(panel01);
		super.getContentPane().add(panel02);
		super.setVisible(true);
	}
	
	protected void jtfFahrenheitEvento(ActionEvent elEvento) {
		try {
			String sGrados = this.jtfFahrenheit.getText();
			double fahrenheit=Double.parseDouble(sGrados);
			double centigrados = 5*(fahrenheit-32)/9; 
			this.jtfCentigrados.setText(String.format("%.2f",centigrados));
		} catch (NumberFormatException laExcepcion ){
			JOptionPane.showMessageDialog(null,"Introducir nmeros reales","Error",JOptionPane.ERROR_MESSAGE);
			this.jtfFahrenheit.setText("32.00");
		}
	}
	protected void jtfCentigradosEvento(ActionEvent elEvento) {
		try {
			String sGrados = this.jtfCentigrados.getText();
			double centigrados =Double.parseDouble(sGrados);
			double fahrenheit= 32+(9*centigrados/5);
			this.jtfFahrenheit.setText(String.format("%.2f",fahrenheit));
		} catch (NumberFormatException laExcepcion ){
			JOptionPane.showMessageDialog(null,"Introducir nmeros reales","Error",JOptionPane.ERROR_MESSAGE);
			this.jtfCentigrados.setText("0.00");
		}
	}
	public static void main(String [] args){
		ConvertidorUI ui= new ConvertidorUI("Convertidor Temperatura");
		ui.iniciar();
	}
}
