
package mx.uls.edu.cib4122006.swingui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JRadioButton;


/**
 * @author gusdelact
 *
 */
public class Layouts extends VentanaInicial {
	
	
	private class Dialogo1 extends JDialog {
		public Dialogo1(){
			this.setLayout(new FlowLayout());
			this.iniciar();
		}
		private void iniciar(){
			
			
			for (int i=0;i<6;i++)
				this.add(new JButton("Presionar "+i));
		}
	}
	private class Dialogo2 extends JDialog {
		public Dialogo2(){
			this.setLayout(new BorderLayout());
			this.iniciar();
		}
		private void iniciar(){
			String []orientacion={ BorderLayout.NORTH,BorderLayout.SOUTH,
					BorderLayout.CENTER,BorderLayout.EAST,BorderLayout.WEST
			};
			for (int i=0;i<orientacion.length;i++)
				this.add(orientacion[i],new JButton("Presionar "+i));
		}
	}
	private class Dialogo3 extends JDialog{
		private CardLayout card;
		public Dialogo3(){
			this.setLayout(card=new CardLayout());
			this.iniciar();
			
		}
		private void iniciar(){
			HandlerBoton h= new HandlerBoton();
			for (int i=0;i<6;i++){
				JButton b=new JButton("Presionar "+i);
				b.addActionListener(h);
				this.add(b,"Card"+i);
			}
		}
		private class HandlerBoton implements ActionListener {	
			public void actionPerformed(ActionEvent arg0) {
				card.next(Dialogo3.this.getContentPane());
				
			}
		}
	}
	private class Dialogo4 extends JDialog{
		public Dialogo4(){
			this.setLayout(new GridLayout(3,4,30,20));
			this.iniciar();
		}
		private void iniciar(){
			for (int i=0;i<10;i++)
				this.add(new JButton("Presionar "+i));
		}
	}
	private class Dialogo5 extends JDialog{
		private GridBagLayout grid;
		public Dialogo5(){
		   this.setLayout(grid=new GridBagLayout());
		   this.iniciar();	
		}
		private void iniciar(){
			GridBagConstraints  constraints= new GridBagConstraints();
			
			constraints.weightx=constraints.weighty=10.0;
			constraints.fill=GridBagConstraints.NONE;
			constraints.ipadx=10;
			constraints.ipady=10;
			JButton b1=new JButton("Press");
			grid.setConstraints(b1,constraints);
			this.add(b1);
			
			constraints.weightx=constraints.weighty=5.0;
			constraints.fill=GridBagConstraints.BOTH;
			constraints.ipadx=0;
			constraints.ipady=0;
			constraints.gridwidth=GridBagConstraints.REMAINDER;
			constraints.gridheight=2;
			constraints.insets= new Insets(10,30,10,20);
			JButton b2=new JButton("Go");
			grid.setConstraints(b2,constraints);
			this.add(b2);
			
			constraints.gridx=0;
			constraints.fill= GridBagConstraints.NONE;
			constraints.ipadx=30;
			constraints.ipady=10;
			constraints.gridwidth=1;
			constraints.gridheight=1;
			JButton b3=new JButton("Push");
			grid.setConstraints(b3,constraints);
			this.add(b3);
			
			
		}
	}
	private class Dialogo6 extends JDialog{
		public Dialogo6(){
			this.setLayout(new BorderLayout());
			this.iniciar();
		}
		private void iniciar(){
			Box caja1= Box.createVerticalBox();
			caja1.add(new JCheckBox("uno"));
			caja1.add(new JCheckBox("dos"));
			caja1.add(new JCheckBox("tres"));
			Box caja2= Box.createVerticalBox();
			caja2.add(new JRadioButton("azul"));
			caja2.add(new JRadioButton("verde"));
			caja2.add(new JRadioButton("rojo"));
			Box caja3= Box.createHorizontalBox();
			caja3.add(caja1);
			caja3.add(caja2);
			Box caja4= Box.createHorizontalBox();
			for (int i=0;i<3;i++)
				caja4.add(new JButton("Boton "+i));
			this.getContentPane().add(caja3,BorderLayout.CENTER);
			this.getContentPane().add(caja4,BorderLayout.SOUTH);
		}
	}
	private class HandlerCombo implements ActionListener {
		private HashMap dialogos;
		
		public HandlerCombo(){
			dialogos = new HashMap();
			dialogos.put("FlowLayout",new Dialogo1());
			dialogos.put("BorderLayout",new Dialogo2());
			dialogos.put("CardLayout", new Dialogo3());
			dialogos.put("GridLayout", new Dialogo4());
			dialogos.put("GridBagLayout", new Dialogo5());
			dialogos.put("BoxLayout", new Dialogo6());
		}
		public void actionPerformed(ActionEvent arg0) {
			seleccionado=(String)jcOpciones.getSelectedItem();
			imprimir(seleccionado);
			imprimirnl();
			Object o = dialogos.get(seleccionado);
			imprimir(o!=null?o.toString():"");
			imprimirnl();
			if (o!=null)
				if (o instanceof JDialog){
					JDialog d=((JDialog)o);
					d.setSize(340,200);
					d.setVisible(true);
				}
		}
	}
	private JComboBox jcOpciones;
	private JButton jbLanzar;
	private String seleccionado;
	
	public void dibujar() {
		Container ct = super.getContainer();
		String [] etiquetas = {"FlowLayout","BorderLayout","CardLayout",
				"GridLayout","GridBagLayout","BoxLayout"
		};
		jcOpciones = new JComboBox();
		for (int i=0;i<etiquetas.length;i++)
			jcOpciones.addItem(etiquetas[i]);
		jcOpciones.addActionListener(new HandlerCombo());
		
		ct.add(jcOpciones);
		
	}
	
	public static void main(String[] args) {
		new Layouts();
	}
}
