
package mx.uls.edu.cib4122006.swingui;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextField;

/**
 * @author Gustavo De la Cruz Tovar
 *
 */
public class MenuComplejo extends VentanaInicial {
	private JFrame fr;
	private String [] sabores;
	private JMenuBar mb1;
	private JMenuBar mb2;
	private JMenu mSabores;
	private JMenu mArchivos;
	private JMenu mSeguridad;
	private JMenu mOtros;
	private JButton jbIntercambiar;
	private JTextField jtf;
	
	private class HandlerSeguridad implements ItemListener {

		public void itemStateChanged(ItemEvent arg0) {
			JCheckBoxMenuItem objetivo = (JCheckBoxMenuItem) arg0.getSource();
			String accion= objetivo.getText();
			if ("Guardar".equals(accion)){
				jtf.setText("!Guardar al helado! "+objetivo.getState());
				
			} else if ("Ocultar".equals(accion)){
				jtf.setText("!Esconder al helado!"+ objetivo.getState());
			}

		}

	}
	
	private class HandlerArchivos implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			JMenuItem objetivo = (JMenuItem) arg0.getSource();
			String opcion=objetivo.getText();
			if ("Abrir".equals(opcion)){
				String s = jtf.getText();
				boolean elegido=false;
				for (int i=0;i<sabores.length && !elegido;i++)
					if (sabores[i].equals(s)) elegido=true;
				if (!elegido)
					jtf.setText("Favor de elegir un sabor");
				else
					jtf.setText("Abriendo "+s);
			} else if ("Cerrar".equals(opcion))
				jtf.setText("");

		}

	}
	
	
	private class HandlerSabores implements ActionListener {
		public void actionPerformed(ActionEvent arg0) {
			JMenuItem objetivo = (JMenuItem) arg0.getSource();
			jtf.setText(objetivo.getText());

		}

	}
	
	private class HandlerCambio implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			JMenuBar m = fr.getJMenuBar();
			fr.setJMenuBar(m==mb1?mb2:mb1);
			fr.validate();

		}

	}
	
	private void construirMenuSabores(){
		sabores= new String []{"Chocolate","Fresa","Hot Fudge Vainilla",
				"Galleta de Menta", "Moka con Almendras","Ron",
				"Cajeta","Queso","Cafe"
				};
		
		HandlerSabores h= new HandlerSabores();
		mSabores = new JMenu("Sabores");
	    for (int i=0;i<sabores.length;i++){
	    	JMenuItem mi = new JMenuItem(sabores[i]);
	    	mSabores.add(mi);
	    	mi.addActionListener(h);
	    	if ((i+1)%3==0)
	    		mSabores.addSeparator();
	    }
	    mSabores.setMnemonic(KeyEvent.VK_S);
	    mb1.add(mSabores);
	    
	}
	private void construirMenuArchivos(){
		mArchivos = new JMenu("Archivos");
		JMenuItem [] jmi= {
				new JMenuItem("Abrir",KeyEvent.VK_A),
				new JMenuItem("Cerrar")
		};
		HandlerArchivos h=new HandlerArchivos();
		for (int i=0;i<jmi.length;i++){
			mArchivos.add(jmi[i]);
			jmi[i].addActionListener(h);
		}	
		
		mArchivos.addSeparator();
		
		JCheckBoxMenuItem [] seguridad = {
			new JCheckBoxMenuItem("Guardar"),
			new JCheckBoxMenuItem("Ocultar")
		};
		mSeguridad = new JMenu("Seguridad");
		HandlerSeguridad hs= new HandlerSeguridad();
		for (int i=0;i<seguridad.length;i++){
			mSeguridad.add(seguridad[i]);
			seguridad[i].addItemListener(hs);
		}
		mSeguridad.setMnemonic(KeyEvent.VK_S);
		
		mArchivos.add(mSeguridad);
		mArchivos.setMnemonic(KeyEvent.VK_A);
		mb1.add(mArchivos);
	}
	private void construirMenuOtros(){
		mOtros = new JMenu("Otros");
		JMenuItem[] otro ={
			new JMenuItem("Foo",KeyEvent.VK_F),
			new JMenuItem("Bar",KeyEvent.VK_A),
			new JMenuItem("Baz")
		};
		for (int i=0;i<otro.length;i++)
			mOtros.add(otro[i]);
		mOtros.setMnemonic(KeyEvent.VK_O);
		mb2.add(mOtros);
	}
	public final void dibujar() {
		Container ct= super.getContainer();
		fr = super.getFrame();
		mb1 = new JMenuBar();
		mb2= new JMenuBar();
		this.construirMenuSabores();
		this.construirMenuArchivos();
		this.construirMenuOtros();
		this.jtf= new JTextField(25);
		this.jtf.setEditable(false);
		this.jbIntercambiar = new JButton("Intercambiar menus");
		this.jbIntercambiar.addActionListener(new  HandlerCambio());
		ct.add(jtf);
		ct.add(this.jbIntercambiar);
		fr.setJMenuBar(mb1);
		
	}

	public static void main(String[] args) {
		new MenuComplejo();
	}
}
