
package mx.uls.edu.cib4122006.swingui;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeMap;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;




/**
 * @author gusdelact
 
 */
public class PanelesTabulados extends VentanaInicial {

	private JTabbedPane tabs;
	
	public void dibujar() {
	   Container ct= super.getContainer();
	   tabs= new JTabbedPane();
	   tabs.addTab("Lista",new PanelLista());
	   tabs.addTab("Opciones",new PanelOpciones());
	   tabs.addTab("Boton",new JButton("boton"));
	   tabs.addTab("Texto",new JTextField(10));
	   JTextArea notas=new JTextArea(5,5);
	   notas.setLineWrap(true);
	   tabs.addTab("Notas",notas);
	   ct.add(tabs);

	}

	public static void main(String[] args) {
		new PanelesTabulados();
	}
	
	private class PanelLista extends JPanel {
		
		
		public PanelLista() {
			super();
			this.dibujar();
		}
		private JList lista;
		private TreeMap diccionario;
		
		private void llenarDiccionario(){
			diccionario = new TreeMap();
			diccionario.put("10","Excelencia");
			diccionario.put("09","Muy Bien");
			diccionario.put("08","Bien");
			diccionario.put("07","Regular");
			diccionario.put("06","Suficiente");
			diccionario.put("05","Reprobado");
		}
		
		public void dibujar() {
			this.llenarDiccionario();
			Set llaves=diccionario.keySet();
			
			lista = new JList(llaves.toArray());
			lista.setVisibleRowCount(3);
			lista.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			lista.addListSelectionListener(new Handler());
			JScrollPane scroller= new JScrollPane (lista);
			scroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			
			this.add(scroller);
			
		}
		private class Handler implements ListSelectionListener {
			public void valueChanged(ListSelectionEvent lse) {
				if (lse.getValueIsAdjusting()){
					String seleccion = (String) lista.getSelectedValue();
					Object valor = diccionario.get(seleccion);
					imprimir(valor.toString());
					imprimirnl();
				}
			}
		}	
	}
	private class PanelOpciones extends JPanel {
		public PanelOpciones() {
			super();
			this.dibujar();
		}
		private HashMap diccionario;
		private  JRadioButton[] opciones;
		public final void dibujar() {
			this.diccionario = new HashMap();
			this.diccionario.put("uno","1");
			this.diccionario.put("dos","2");
			this.diccionario.put("tres","3");
			
			ButtonGroup grupo = new ButtonGroup();
			opciones = new JRadioButton [] {
					new JRadioButton("uno",false),
					new JRadioButton("dos",false),
					new JRadioButton("tres",false)
			};
			for (int i=0;i<opciones.length;i++){
			   grupo.add(opciones[i]);
			   add(opciones[i]);
			   opciones[i].addActionListener(new Handler());
			}
		}
		private class Handler implements ActionListener {
			
			public void actionPerformed(ActionEvent arg0) {
				Object fuente = arg0.getSource();
				JRadioButton opcion = (JRadioButton) fuente;
				String palabra = opcion.getText();
				String numero = (String) diccionario.get(palabra);
				imprimir(numero);
				imprimirnl();
				
			}
		}

	}
}
