
package mx.uls.edu.cib4122006.swingui;

import java.awt.BorderLayout;
import java.io.File;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;


public class TablaArchivo extends JFrame {

	private class ArchivoModelo implements TableModel {

		private File dir;
		private String[] fileNames;
		private String[] nombres= {
			"nombre",
			"tamanio",
			"ultima modificacion",
			"directorio",
			"escritura?",
			"lectura?"
		};
		
		private Class[] clases= {
				String.class,
				Long.class,
				Date.class,
				Boolean.class,
				Boolean.class,
				Boolean.class
		};
		
		ArchivoModelo(File dir) {
			super();
			this.dir = dir;
			this.fileNames= this.dir.list();
		}
		
		public int getRowCount() {
			return this.fileNames.length;
		}

		
		public int getColumnCount() {
			return 6;
		}

		
		public String getColumnName(int indice) {
			return this.nombres[indice];
		}

		
		public Class getColumnClass(int indice) {
		
			return this.clases[indice];
		}

		public boolean isCellEditable(int arg0, int arg1) {
			// TODO Auto-generated method stub
			return false;
		}


		public Object getValueAt(int row, int col) {
			Object retorno=null;
			File f= new File(dir,this.fileNames[row]);
			switch (col){
				case 0:
					retorno= this.fileNames[row];
					break;
				case 1:
					retorno = new Long(f.length());
					break;
				case 2:
					retorno = new Date(f.lastModified());
					break;
				case 3:
					retorno = new Boolean(f.isDirectory());
					break;
				case 4:
					retorno = new Boolean(f.canWrite());
					break;
				case 5:
					retorno = new Boolean(f.canRead());
					break;
		
				default: 
					break;
			}
			return retorno;
		}

		
		public void setValueAt(Object arg0, int arg1, int arg2) {
			// TODO Auto-generated method stub

		}

		
		public void addTableModelListener(TableModelListener arg0) {
		

		}

		
		public void removeTableModelListener(TableModelListener arg0) {
		

		}

	}
	public void iniciar(){
		super.setSize(320,480);
		super.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		JTable tabla = new JTable(
				new ArchivoModelo(new File(
						System.getProperty("user.home")
					)));
		JScrollPane scroll = new JScrollPane(tabla);
		super.getContentPane().add(scroll,BorderLayout.CENTER);
		super.setVisible(true);
	}
	public static void main(String[] args) {
		(new TablaArchivo()).iniciar();
	}
}
